import zope.interface
from zope.interface import implements
from zope.app.container.btree import BTreeContainer
from zope.app.container.contained import Contained
from datetime import datetime
from interfaces import IWorkLogEntry, IWorkLog, IWorkLogEntryContained, IWorkLogContained, IWorkLogContainer
from pytz import utc
from person import Person
from persistent import Persistent

class WorkLogEntry(Contained, Persistent):
    """An implementations of IWorkLogEntry."""
    implements(IWorkLogEntry, IWorkLogEntryContained)
    workDone = u""
    learned = u""
    __endTime = utc.localize(datetime.utcnow())
   
    def __init__(self):
        self.__endTime = utc.localize(datetime.utcnow())
        self.startTime = utc.localize(datetime.utcnow())

    def getEndTime(self):
        return self.__endTime

    def setEndTime(self, argument):
        self.__endTime = argument or utc.localize(datetime.utcnow())

    endTime = property(getEndTime, setEndTime)

class WorkLog(BTreeContainer, Persistent):
    """Container of IWorkLogEntries."""	
    implements(IWorkLog, IWorkLogContained)
    __person = Person()
    def __init__(self):
        super(WorkLog, self).__init__()
        self.__person = Person()
        self.__person.title = u"Homsar"

    def getPerson (self):
        return self.__person

    def setPerson (self, argument):
        self.__person = Person()
        self.__person.title = u"Homsar"
    
    person = property(getPerson, setPerson)
    title = u""
    clockedIn = False
    submitted = []


class WorkLogContainer(BTreeContainer, Persistent):
    """Container of IWorkLogs."""
    implements(IWorkLogContainer)
